/* ========================================================================
   Copyright 2014 by Ernic Innovative Technologies CC. All rights reserved.
   No unauthorised use of this code is allow without explicit permission from
   Erhard Smit and can be contacted at erhard@ernic.co.za.
   ========================================================================
   File Name:   ernic.contentprovider.js
   Description: Functions to request content locally and remotely via ajax
                calls and to handle form submissions. Supports caching and
                dynamic content injection.
   ========================================================================

*/

var databag = Array();
var has_more_offline_content = false;
var apphist = new Array();
var retrycount = 0;


function ToObject(arr) {
  var rv = {};
  for (var i = 0; i < arr.length; ++i)
    rv[i] = arr[i];
  return rv;
}

function ToKVP(arr) {
  var rv = "";
  
  for (var key in arr) 
  {
    if (arr.hasOwnProperty(key))  
    {
     if(rv != "")
        rv += "&";
     rv += key + '=' + arr[key];
    }
  }
  return rv;
}

function GetDatabag()
{
    var i = 0, //i is standing for int
    databagobj = {}, //o is standing for object
    sKey; //s is standing for string
    while ((sKey = window.localStorage.key(i))) 
    {
        if(sKey.indexOf('response_') < 0)
            databagobj[sKey] = window.localStorage.getItem(sKey);
        i++;
    }    
    databag = databagobj;
    return databag;
}

function SetDatabag(data)
{
   if((data.databag != null) && (data.databag.length != 0))
   {
        var empty = true;
        for (var name in data.databag) {
            if(databag[name] == null)
                window.localStorage.removeItem(name);
            else
                window.localStorage.setItem(name,databag[name]);
            empty = false;
        }
        
        if(!empty)
        {
            databag = data.databag;                    
        }
   }      
}

function LoadOfflineVersion(action)
{
    alert('LoadOfflineVersion');
    HideBusy(); 
    data = window.localStorage.getItem('response_' + action);
    if(data != null)
    {
        LoadContentCallback(JSON.parse(data),'main',false);
    }
    else
        ShowMessage('Network Error','<p>The network seem to be unavailable and there are no local cache available. </p><p>Please check your internet connectivity or try again later.</p>')          
}

function SaveOfflineVersion(action,data)
{
    window.localStorage.setItem('response_' + action,JSON.stringify(data))
}

function SaveFormContentOffline(action,formid,postdata)
{    
    timestamp = new Date().getTime();
    key = 'form_' + formid + '_' + action + '_' + timestamp;
    window.localStorage.setItem(key,postdata);
    HideBusy();
}

function SyncOfflineFormContent()
{
    var i = 0, //i is standing for int
    sKey; //s is standing for string
    while ((sKey = window.localStorage.key(i))) 
    {        
        if(sKey.indexOf('form_') > -1)
        {
            postdata = window.localStorage.getItem(sKey);
            parts = sKey.split('_');
            formid = parts[1];
            actionid = parts[2];
            
            if((postdata != null) && (postdata != ''))
                postdata += '&offlinedatakey=' + sKey;
            else
                postdata += 'offlinedatakey=' + sKey;                        
            
            SubmitOfflineFormContent(formid,actionid,postdata);
            has_more_offline_content = true;
            return;
        }
        i++;
    }
    has_more_offline_content = false;    
}

function LoadRemoteContent(url,divid)
{
    var opts={
        type:"GET",
        success:function(data){
            $(divid).html(data);        
        },
        url:APPSERVER + '/' + url
    }
    $.ajax(opts);
}

function LoadContentCallback(data,panel,clearhistory)
{   
   retrycount = 0;
   
   if(data.blankurl != null)
   {
      window.open(data.blankurl,'_system');
   }
   
   if(data.systemurl != null)
   {
      window.open(data.systemurl,'_system');
   }
           
   HideBusy();      
   
   SetDatabag(data);    
   
   if(data.redirect != null)
   {
      LoadContent(data.redirect,panel,false);
      if(data.messagetitle != null)
         ShowMessage(data.messagetitle,data.message);  
      return;
   }

   SaveOfflineVersion($('#currentaction').val(),data);         
   
//   SetupNavPanels(data);
      
   if(data.title != null)   
   {
      $.ui.setTitle(data.title);
   }
    
   if(data.html != null) 
      $.ui.updatePanel('#' + panel,data.html);
   $.ui.loadContent('#' + panel,false,false,"right");  
   if(clearhistory)
      $.ui.clearHistory();
      
   $.ui.scrollToTop(panel);
   
   if(data.back)
      $("#backbutton").show();
   else
      $("#backbutton").hide();     
   if(data.backjs != null)
      $("#backbutton").attr("onclick",data.backjs);    
   
   if(data.messagetitle != null)
       ShowMessage(data.messagetitle,data.message);      

   if(navigator.onLine)
      SyncOfflineFormContent();
      
   UpdateAccountMenus();   
   
   UpdateToolbarSelectedButtons(data.title);   
}

function LoadContent(action,panel,clearhistory)
{
   if((action != $("#prevaction").val()) && ($("#prevaction").val() != ""))
      apphist.push($("#prevaction").val());    
   $("#prevaction").val(action);
   $("#currentaction").val(action); 
   $("#currentpanel").val(panel);
         
   var postdata = new Object();   
   
   if((databag == null) || (databag.length == 0))
      postdata.hasdatabag = false;
   else
   {
      postdata.hasdatabag = true;
      postdata.databag = ToKVP(databag,"databag");
   }
   
   var postdatakvp = $.param(postdata,"data");  // turn postdata into a key value pair   
    
   ShowBusy(); 

   $.ajax({
      type:"GET",
      url: APPSERVER + '/' + action, 
      contentType:"application/json",
      data: postdatakvp, 
      success:function(data){       
         LoadContentCallback(data,panel,clearhistory);         
      },
      error:function(data,status,er){
         if(retrycount < 3)
         {
            LoadContent(action,panel,clearhistory);
            retrycount++;
         }
         else
         {
            ShowMessage('Error Occured','The server could not be reached. Please check your internet connectivity and try again.');
         }
      }
   });
}

function SubmitFormContent(action,formid,allowoffline)
{      
   if($('#deviceid') != undefined)
   {
       $('#deviceid').val(window.localStorage.getItem('deviceid'));
   } 
    
   if((action != $("#prevaction").val()) && ($("#prevaction").val() != ""))
      apphist.push($("#prevaction").val());    
   $("#prevaction").val(action);
      
   var postdata = new Array();
   if((databag == null) || (databag.length == 0))
      postdata.hasdatabag = false;
   else
   {
      postdata.hasdatabag = true;
      postdata.databag = ToKVP(databag,"databag");
   }
   
   postdata['form'] = $("#" + formid).serialize();
   var postdatakvp = $.param(postdata,"data");  // turn postdata into a key value pair
         
   ShowBusy(); 
      
   $.ajax({
      type:"GET",
      url: APPSERVER + '/' + action, 
      contentType:"application/json",
      data: postdatakvp,  
      success:function(data){          
         LoadContentCallback(data,'main',false);         
      },
      error:function(data,status,er){   
        alert(er);   
        ShowMessage('Error Occured','The server could not be reached. Please check your internet connectivity and try again.');         
      }
   });
}

function SubmitOfflineFormContentCallback(data)
{    
    if(data.offlinedatakey != null)
        window.localStorage.removeItem(data.offlinedatakey);
    
   if(data.messagetitle != null)
       alert(data.message);       
    
    if(has_more_offline_content)
    {
        if(navigator.onLine)
            SyncOfflineFormContent();
    }
}

function SubmitOfflineFormContent(action,formid,postdata)
{           
   $.ajax({
      type:"GET",
      url: APPSERVER + '/' + action, 
      dataType: 'text',
      data: postdata, 
      success:function(data){          
         SubmitOfflineFormContentCallback(JSON.parse(data),'main',false);         
      },
      error:function(data){
          console.log(data);    
          alert('Ajax LoadContent Error: ' + data);            
      }
   });   
}

function Logout()
{    
    window.localStorage.removeItem('userid',null);
    window.localStorage.clear();     
    databag = [];    
    AppStarted();
}

function SetDeviceToken(token)
{
    if((token != null) && (token != undefined) && (token != ''))
    {
        if(window.localStorage.getItem('userid') != null)
        {
            $.ajax({
                type:"GET",
                contentType:"application/json",
                url: APPSERVER + '/mobile/setdeviceid', 
                contentType:"application/json",
                data: 'userid=' + window.localStorage.getItem('userid') + "&deviceid=" + token, 
                success:function(data){       
                    alert('here');
                    alert(data.success);
                },
                error:function(data,status,er){             
                }
            });
       }
    }
}

