/* ========================================================================
   Copyright 2014 by Ernic Innovative Technologies CC. All rights reserved.
   No unauthorised use of this code is allow without explicit permission from
   Erhard Smit and can be contacted at erhard@ernic.co.za.
   ========================================================================
   File Name:   ernic.utils.js
   Description: Common utility functions used from apps.
   ========================================================================

*/

/*
    function OpenInAppBrowser(url)
    ========================================================================
    Use this function from a javascript call in a view to open an external
    URL from within the app's own built-in browser. Once the view is closed 
    control is returned to the app.
*/
function OpenInAppBrowser(url)
{
	window.open(url,'_blank');
}

/*
    function OpenInSystemBrowser(url)
    ========================================================================
    Use this function from a javascript call in a view to open an external
    URL from the phone's system browser. Ideal to open a PDF for example with
    this call to load in the default PDF viewer for.
*/
function OpenInSystemBrowser(url)
{
	window.open(url,'_system');
}


/*
    function ValidEmail(email) 
    ========================================================================
    Use this function to validate an email address format from javascript.
*/
function ValidEmail(email) 
{    
    var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;

    if (!filter.test(email)) 
        return false;    
    else
        return true;
}

/*
    function function DayOfWeek(d) 
    ========================================================================
    Use this function to get the name of the day of the week. If you pass null 
    it will use today's date.
*/
function DayOfWeek(d)
{
    if(d == null)
        var d = new Date();
    var n = d.getDay(); 
    if(n == 0)
        return 'Sunday';
    else if(n == 1)
        return 'Monday';
    else if(n == 2)
        return 'Tuesday';        
    else if(n == 3)
        return 'Wednesday';        
    else if(n == 4)
        return 'Thursday';        
    else if(n == 5)
        return 'Friday';        
    else if(n == 6)
        return 'Saturday';        
}

/*
    function function function GetHour(d) 
    ========================================================================
    Use this function to get the hour of the day. If you pass null 
    it will use today's date.
*/
function GetHour(d)
{
    if(d == null)
        var d = new Date();
    return d.getHours();
}

/*
    function GetMinute(d)
    ========================================================================
    Use this function to get the minute of the day. If you pass null 
    it will use today's date.
*/
function GetMinute(d)
{
    if(d == null)
        var d = new Date();
    return d.getMinutes();
}