function SubmitChatTopic()
{
    if($('#chattopicTopicTitle').val() == '')
    {
        ShowMessage('Validation Error','Please enter a topic for the chat.');
        return false;
    }    
    else if($('#chattopicTopicMessage').val() == '')
    {
        ShowMessage('Validation Error','Please enter an introduction message about your chat topic.');
        return false;
    }    
    else if(!$('#chattopicTopicAgree').is(":checked"))
    {
        ShowMessage('Validation Error','You have to agree to the chat rules before you can post a topic.');
        return false;
    }
    else
        SubmitFormContent('mobile/chattopic','chattopicForm',false);    
}

function SubmitChatReply()
{
    if($('#chattopicTopicReply').val() == '')
    {
        ShowMessage('Validation Error','Please enter your reply message.');
        return false;
    }    
    else if(!$('#chattopicTopicReplyAgree').is(":checked"))
    {
        ShowMessage('Validation Error','You have to agree to the chat rules before you can post a reply.');
        return false;
    }
    else
        SubmitFormContent('mobile/chatreply','chattopicReplyForm',false);    
}

function LeagueSelected(leagueid)
{
    databag['leagueid'] = leagueid;
    LoadContent($('#currentaction').val(),$('#currentpanel').val(),false);
}

function RegistrationEmailEntered()
{
    $('#bankref').html($('#registerEmail').val());
}

function PaymentSelected(option)
{
    if(option == 'eft')
        $('#eft').show(); 
    else
        $('#eft').hide();         
}

function OpenMemberSection(action,panel,clearhistory)
{
    if(window.localStorage.getItem('userid') == null)
    {
        LoadContent('mobile/module/membership','membership',false);
    }
    else
    {
        LoadContent(action,panel,clearhistory);
    }
}

function UpdateToolbarSelectedButtons(title)
{    
    $('#navbar_home').removeClass('pressed');
    $('#navbar_live').removeClass('pressed');
    $('#navbar_share').removeClass('pressed');
    $('#navbar_chat').removeClass('pressed');
    
    if(title == 'Home')
        $('#navbar_home').addClass('pressed');    
    if(title == 'Live Scoring')
        $('#navbar_live').addClass('pressed');        
    if(title == 'Chat')
        $('#navbar_chat').addClass('pressed');                
}

function SignIn()
{    
    if(($('#signinEmail').val() == '') || (!ValidEmail($('#signinEmail').val())))
    {
        ShowMessage('Validation Error','Please enter a valid email address.');
        return false;
    }
    else if($('#signinPassword').val() == '')
    {
        ShowMessage('Validation Error','Please enter your password.');
        return false;
    }
    else
        SubmitFormContent('mobile/signin','signinForm',false);
}

function SendPassword()
{
    if(($('#forgotEmail').val() == '') || (!ValidEmail($('#forgotEmail').val())))
    {
        ShowMessage('Validation Error','Please enter a valid email address.');
        return false;
    }    
    else
        SubmitFormContent('mobile/forgotpassword','forgotpasswordForm',false);
}

function Register()
{
    if($('#registerUsername').val() == '')
    {
        ShowMessage('Validation Error','Please enter a username to use on the app to login, in chat rooms etc.');
        return false;
    }
    else if(($('#registerEmail').val() == '') || (!ValidEmail($('#registerEmail').val())))
    {
        ShowMessage('Validation Error','Please enter a valid email address.');
        return false;
    }
    else if($('#registerPassword').val() == '')
    {
        ShowMessage('Validation Error','Please enter your password.');
        return false;
    }
    else if($('#registerPassword').val() != $('#registerConfirmPassword').val())
    {
        ShowMessage('Validation Error','Please re-enter and confirm your password.');
        return false;
    }
    else
        SubmitFormContent('mobile/register','registerForm',false);
}

function SaveSettings()
{
    if (($('#registerPassword').val() != '') && ($('#registerPassword').val() != $('#registerConfirmPassword').val()))
    {
        ShowMessage('Validation Error','Please re-enter and confirm your password.');
        return false;
    }
    else
        SubmitFormContent('mobile/mysettings','mysettingsForm',false);
}

function ContactUs()
{
    if($('#contactusName').val() == '')
    {
        ShowMessage('Validation Error','Please enter your name.');
        return false;
    }    
    else if($('#contactusComments').val() == '')
    {
        ShowMessage('Validation Error','Please enter your comments.');
        return false;
    }
    else
        SubmitFormContent('mobile/contactus','contactusForm',false);    
}